/**
 * @file        adaptor_api.h
 * @brief       library for providing adaptor API

 * Copyright (c) 2017 Samsung Electronics Co., Ltd.
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information"). You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung.
 */

#ifndef __ADAPTOR_API_H__
#define __ADAPTOR_API_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "adaptor_api_types.h"

#ifndef API
#define API __attribute__ ((visibility("default")))
#endif

/**
 * @fn        int device_reboot(void)
 * @brief     this function to reboot target device
 * @param     void
 * @return    int 			return of function
 */
API int device_reboot(void);

/**
 * @fn        int get_os_info(void)
 * @brief     this function to get os information
 * @param     *os_info		[out] fill os information
 * @return    int 			return of function
 */
API int get_os_info(os_info_s * os_info);

/**
 * @fn        int device_reboot(void)
 * @brief     this function to get disk information
 * @param     *disk_info		[out] fill disk information
 * @return    int 			return of function
 */
API int get_disk_info(disk_info_s * disk_info);

/**
 * @fn        int factory_restore(void)
 * @brief     this function to restore factory state
 * @param     void
 * @return    int 			return of function
 */
API int factory_restore();

#ifdef __cplusplus
}
#endif

#endif /* __ADAPTOR_API_H__ */
