/**
 * @file        ipc_client.h
 * @brief       client part using ipc methods

 * Copyright (c) 2017 Samsung Electronics Co., Ltd.
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information"). You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung.
 */

#ifndef __IPC_CLIENT_H__
#define __IPC_CLIENT_H__

/**
 * @fn        int IPC_CallFunction(char *data, int size, char **retbuf)
 * @brief     this function to send data through IPC
 * @param     *data         [in] send data
 * @param     size          [in] size of data
 * @param     **retbuf      [in] return buffer string
 * @return    int       result of function
 */
int IPC_CallFunction(char *data, int size, char **retbuf);

/**
 * @fn        int IPC_RegisterCallback(void)
 * @brief     this function to register callback
 * @return    int   result of function
 */
int IPC_RegisterCallback(void);

#endif  /* __IPC_CLIENT_H__ */
