/*
 * Copyright (c) 2016-2017 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef __SA_COMMON_H__
#define __SA_COMMON_H__

#include <unistd.h>
#include <string.h>

#if defined(GBS_BUILD)
#include <dlog.h>
#endif

#ifdef LOG_TAG
#undef LOG_TAG
#endif

#define LOG_TAG "docker-adaptor"

#ifdef MIN
#undef MIN
#endif

#define MIN(X, Y) ((X) < (Y) ? (X) : (Y))
#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

#define __FILENAME__ (strrchr(__FILE__, '/') ? strrchr(__FILE__, '/') + 1 : __FILE__)

#if defined(GBS_BUILD)
#if !defined(_D)
#define _D(fmt, arg...) dlog_print(DLOG_DEBUG, LOG_TAG, "%s: %s[%d]\t " #fmt "\n", __FILENAME__, __FUNCTION__, __LINE__, ##arg)
#endif

#if !defined(_W)
#define _W(fmt, arg...) dlog_print(DLOG_WARN, LOG_TAG, "%s: %s[%d]\t " #fmt "\n", __FILENAME__, __FUNCTION__ , __LINE__, ##arg)
#endif

#if !defined(_E)
#define _E(fmt, arg...) dlog_print(DLOG_ERROR, LOG_TAG, "%s: %s[%d]\t " #fmt "\n", __FILENAME__, __FUNCTION__ , __LINE__, ##arg)
#endif
#else							// DGBS_BUILD

#define RST		"\033[0m"
#define RED		"\033[0;31m"
#define IRED	"\033[1;91m"

#define _D(fmt, ...)	printf(RST "%s: %s[%d]\t " #fmt "\n", __FILENAME__, __FUNCTION__ , __LINE__, ##__VA_ARGS__)
#define _W(fmt, ...)	printf(RED "%s: %s[%d]\t " #fmt RST "\n", __FILENAME__, __FUNCTION__ , __LINE__, ##__VA_ARGS__)
#define _E(fmt, ...)	printf(IRED "%s: %s[%d]\t " #fmt RST "\n", __FILENAME__, __FUNCTION__ , __LINE__, ##__VA_ARGS__)

#endif							// DGBS_BUILD

#endif							/* __SA_COMMON_H__ */
